bool isNotCTF(Track::TrackObject@ obj)
{
    return Track::getMinorRaceMode() != 2002;
}

bool isCTF(Track::TrackObject@ obj)
{
    return Track::getMinorRaceMode() == 2002;
}

bool isNotFFA(Track::TrackObject@ obj)
{
    return Track::getMinorRaceMode() != 2001 && Track::getMinorRaceMode() != 2000;
}

bool isFFA_zero()
{
    return Track::getMinorRaceMode() == 2001 || Track::getMinorRaceMode() == 2000;
}

bool isFFA(Track::TrackObject@ obj)
{
    return isFFA_zero();
}

bool isNotSoccer(Track::TrackObject@ obj)
{
    return Track::getMinorRaceMode() != 2003;
}

bool isSoccer(Track::TrackObject@ obj)
{
    return Track::getMinorRaceMode() == 2003;
}

int podiums_cnt = 19;
int phase;
int total_phases = 30;
int interval = 20;
int ffa_interval = 12;
int offset = 3;
array<int> how_many_karts = {0,
     9,  9, 11, 10, 11,
    11, 12, 10, 11, 12,
    11, 11,  9,  9,  8,
     9,  9,
0};

bool hmm(Track::TrackObject@ obj)
{
    return false;
}

Track::TrackObject@ getPodium(int x) {
    return Track::getTrackObject("", "Movement." + formatInt(x, "0", 3));
}

Track::TrackObject@ getKart(int x, int y) {
    return Track::getTrackObject("", "PodiumKart" + formatInt(x, "0", 3) + "." + formatInt(y, "0", 3));
}

void selectPodium(int idx) {
    for (int i = 0; i < podiums_cnt; ++i) {
        bool value = false;
        if (i == idx) {
            value = true;
        }
        getPodium(i).setEnabled(value);
        for (int j = 1; j <= how_many_karts[i]; ++j) {
            getKart(i, j).setEnabled(value);
        }
    }
}

void timer() {
    phase += 1;
    if (phase == total_phases)
        phase = 0;
    if (phase >= offset && phase < offset + podiums_cnt)
        selectPodium(phase - offset);
    else
        selectPodium(-1);
    Utils::setTimeout("timer", interval);
}

void onStart() {
    if (isFFA_zero())
        interval = ffa_interval;
    selectPodium(-1);
    phase = -1;
    Utils::setTimeout("timer", interval);
}

void moveKartInsidePodium(int kart_id) {
    Vec3 position = Track::getTrackObject("", "PointerInsidePodium").getCenterPosition();
    if (Track::getKartType(kart_id) != 2) // bot according to RX1
        Kart::teleportExact(kart_id, position);
}
